var notifications = true;


browser.runtime.onMessage.addListener(function(message, tab) {
  var id_tab = tab.tab.id;
  var msg_decoded = JSON.parse(message);
  if (msg_decoded.status === 'print') {
    browser.storage.local.get("himp").then(function(options) {
      var params;
      if (options.himp !== undefined) {
        if (options.himp.notifications === false) {
          notifications = false;
        } else {
          notifications = true;
        }
        params = options.himp;
      } else {
        params = {
          ip: "127.0.0.1",
          port: 8999,
        };
        notifications = true;
      }
      ajax({
        url: 'http://' + params.ip + ':' + params.port + '/hiboutik/' + msg_decoded.msg + '/',
        onSuccess: function(data) {
          notifyRouter(data, params);
        },
        onError: function(status, request) {
          errorHndling(status, request, params);
        }
      });
    });
  }
});


function errorHndling(status, request, params) {
  console.log("Error: " + status);
  switch(status) {
    case 0:
      notifyRouter({
        ver: 1,
        status: 'error',
        msg: 'himp_not_found'
      }, params);
      break;
    case 404:
      notifyRouter({
        ver: 1,
        status: 'error',
        msg: 'himp_not_found'
      }, params);
      break;
    case 500:
      notifyRouter({
        ver: 1,
        status: 'error',
        msg: 'internal_error'
      }, params);
      break;

    default:
      notifyRouter({
        ver: 1,
        status: 'error',
        msg: 'internal_error'
      }, params);
  }
}




function notifyRouter(data, params) {
  switch (data.status) {
    case "info":
      switch (data.msg) {
        case "no_ticket":
          notify({
            title: 'Hiboutik',
            message: browser.i18n.getMessage("noTicket")
          });
          break;
        case "local_print":
          if (notifications === true) {
            notify({
              title: 'Hiboutik',
              message: browser.i18n.getMessage("localPrint") + ': ' + (data.body ? (' ' + data.body) : '?')
            });
          }
          break;
        case "network_print":
          if (notifications === true) {
            notify({
              title: 'Hiboutik',
              message: browser.i18n.getMessage("networkPrint") + (data.body ? (' ' + data.body) : '')
            });
          }
          break;
      }
      break;

    case "error":
      switch (data.msg) {
        case "malformed_url":// New
          notify({
            title: 'Hiboutik',
            message: browser.i18n.getMessage("errorUrlAccount")
          });
          break;
        case "account_name_parse":
          notify({
            title: 'Hiboutik',
            message: browser.i18n.getMessage("errorUrlAccount")
          });
          break;
        case "stream_error":
          notify({
            title: 'Hiboutik',
            message: browser.i18n.getMessage("streamError")
          });
          break;
        case "connection_error":
          notify({
            title: 'Hiboutik',
            message: browser.i18n.getMessage("streamError")
          });
          break;
        case "no_account":
          notify({
            title: 'Hiboutik',
            message: browser.i18n.getMessage("noAccount")
          });
          break;
        case "local_printer_unreacheable":
          notify({
            title: 'Hiboutik',
            message: browser.i18n.getMessage("localPrinterUnreacheable")
          });
          break;
        case "network_printer_unreacheable":
          notify({
            title: 'Hiboutik',
            message: browser.i18n.getMessage("networkPrinterUnreacheable")
          });
          break;
        case "url_account":
          notify({
            title: 'Hiboutik',
            message: browser.i18n.getMessage("errorUrlAccount")
          });
          break;
        case "himp_not_found":
          notify({
            title: 'Hiboutik',
            message: browser.i18n.getMessage("resourceNotFound") + ': ' + params.ip + ':' + params.port
          });
          break;
        case "internal_error":
          notify({
            title: 'Hiboutik',
            message: browser.i18n.getMessage("internalError")
          });
          break;
        case "printer_not_found":
          notify({
            title: 'Hiboutik',
            message: browser.i18n.getMessage("printerNotFound")
          });
          break;
        case "unknown_error":
          notify({
            title: 'Hiboutik',
            message: browser.i18n.getMessage("unknownError")
          });
          break;
      }
      break;

    case "warning":
      switch (data.msg) {
        case "update":
          notify({
            title: 'Hiboutik',
            message: browser.i18n.getMessage("update")
          });
          break;
        case "printer_type":
          notify({
            title: 'Hiboutik',
            message: browser.i18n.getMessage("printerTypeError")
          });
          break;
      }
      break;
  }
}




function notify(params) {
  browser.notifications.create({
    type: "basic",
    iconUrl: browser.extension.getURL("icons/" + (params.icon || 'himp-48.png')),
    title: params.title || '',
    message: params.message || ''
  });
}
